=== debian/control ===
Source: pothos-flow
Section: science
Priority: optional
Maintainer: Josh Blum <josh@pothosware.com>
Build-Depends:
    debhelper (>= 9.0.0),
    cmake (>= 2.8.9),
    libpoco-dev (>= 1.6),
    libpothos-dev,
    qtbase5-dev
Standards-Version: 4.1.4
Homepage: https://github.com/pothosware/PothosFlow/wiki
Vcs-Git: https://github.com/pothosware/PothosFlow.git
Vcs-Browser: https://github.com/pothosware/PothosFlow

Package: pothos-flow
Section: libs
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends:
    libpothosqtcolorpicker0 (= ${binary:Version}),
    pothos0.7-modules-flow,
    ${shlibs:Depends},
    ${misc:Depends},
    xdg-utils,
    graphviz
Replaces: pothos-gui
Description: graphical design tool
 The Pothos data-flow software suite.

Package: libpothosqtcolorpicker0
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: color picker widget library
 The Pothos data-flow software suite.

Package: pothos0.7-modules-flow
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: graphical design tool - plugins
 The Pothos data-flow software suite.
